## mold 1.3.0+dfsg

=== Makefile ===
VERSION = 1.3.0

PREFIX = /usr/local
BINDIR = $(PREFIX)/bin
LIBDIR = $(PREFIX)/lib
LIBEXECDIR = $(PREFIX)/libexec
MANDIR = $(PREFIX)/share/man

INSTALL = install
INSTALL_PROGRAM = $(INSTALL)
INSTALL_DATA = $(INSTALL) -m 644

D = $(DESTDIR)

# CXX defaults to `g++`. Rewrite it with a vendor-neutral compiler
# name `c++`.
ifeq ($(origin CXX), default)
  CXX = c++
endif

# If you want to keep symbols in the installed binary, run make with
# `STRIP=true` to run /bin/true instead of the strip command.
STRIP = strip

SRCS = $(wildcard *.cc elf/*.cc macho/*.cc)
OBJS = $(SRCS:%.cc=out/%.o)

OS := $(shell uname -s)
ARCH := $(shell uname -m)

IS_ANDROID = 0
ifneq ($(findstring -android,$(shell $(CC) -dumpmachine)),)
  IS_ANDROID = 1
endif

# If you want to compile mold for debugging, invoke make as
# `make CXXFLAGS=-g`.
CFLAGS = -O2
CXXFLAGS = -O2

MOLD_CXXFLAGS := -std=c++20 -fno-exceptions -fno-unwind-tables \
                 -fno-asynchronous-unwind-tables -Ithird-party/xxhash \
                 -DMOLD_VERSION=\"$(VERSION)\" -DLIBDIR="\"$(LIBDIR)\""

MOLD_LDFLAGS := -pthread -lz -lm -ldl

# Get a hash of the current git head. We don't want to use the git
# command because the command prints out a warning if running under
# sudo.
GIT_HASH := $(shell [ -f .git/HEAD ] && if grep -q '^ref:' .git/HEAD; then cat .git/`sed 's/^ref: //' .git/HEAD`; else cat .git/HEAD; fi)

ifneq ($(GIT_HASH),)
  MOLD_CXXFLAGS += -DGIT_HASH=\"$(GIT_HASH)\"
endif

LTO = 0
ifeq ($(LTO), 1)
  CXXFLAGS += -flto -O3
  LDFLAGS  += -flto
endif

# By default, we want to use mimalloc as a memory allocator. mimalloc
# is disabled on macOS and Android because it didn't work on those hosts.
USE_MIMALLOC = 1
ifeq ($(OS), Darwin)
  USE_MIMALLOC = 0
else ifeq ($(IS_ANDROID), 1)
  USE_MIMALLOC = 0
endif

ifeq ($(USE_MIMALLOC), 1)
  ifdef SYSTEM_MIMALLOC
    MOLD_CXXFLAGS += -DUSE_SYSTEM_MIMALLOC
    MOLD_LDFLAGS += -lmimalloc
  else
    MIMALLOC_LIB = out/mimalloc/libmimalloc.a
    MOLD_CXXFLAGS += -Ithird-party/mimalloc/include
    MOLD_LDFLAGS += -Wl,-whole-archive $(MIMALLOC_LIB) -Wl,-no-whole-archive
  endif
endif

ifdef SYSTEM_TBB
  MOLD_LDFLAGS += -ltbb
else
  TBB_LIB = out/tbb/libs/libtbb.a
  MOLD_LDFLAGS += $(TBB_LIB)
  MOLD_CXXFLAGS += -Ithird-party/tbb/include
endif

ifeq ($(OS), Linux)
  ifeq ($(IS_ANDROID), 0)
    # glibc before 2.17 need librt for clock_gettime
    MOLD_LDFLAGS += -Wl,-push-state -Wl,-as-needed -lrt -Wl,-pop-state
  endif
endif

NEEDS_LIBCRYPTO = 1
ifeq ($(OS), Darwin)
  NEEDS_LIBCRYPTO = 0
endif

ifeq ($(NEEDS_LIBCRYPTO), 1)
  MOLD_LDFLAGS += -lcrypto
endif

# '-latomic' flag is needed building on riscv64 system.
# Seems like '-atomic' would be better but not working.
ifeq ($(ARCH), riscv64)
  MOLD_LDFLAGS += -latomic
endif

# -Wc++11-narrowing is a fatal error on Android, so disable it.
ifeq ($(IS_ANDROID), 1)
  MOLD_CXXFLAGS += -Wno-c++11-narrowing
endif

ifeq ($(OS), Linux)
  MOLD_WRAPPER_LDFLAGS = -Wl,-push-state -Wl,-no-as-needed -ldl -Wl,-pop-state
endif

DEPFLAGS = -MT $@ -MMD -MP -MF out/$*.d

all: mold mold-wrapper.so

-include $(SRCS:%.cc=out/%.d)

mold: $(OBJS) $(MIMALLOC_LIB) $(TBB_LIB)
	$(CXX) $(OBJS) -o $@ $(MOLD_LDFLAGS) $(LDFLAGS)
	ln -sf mold ld
	ln -sf mold ld64

mold-wrapper.so: elf/mold-wrapper.c
	$(CC) $(DEPFLAGS) $(CFLAGS) -fPIC -shared -o $@ $< $(MOLD_WRAPPER_LDFLAGS) $(LDFLAGS)

out/%.o: %.cc out/elf/.keep out/macho/.keep
	$(CXX) $(MOLD_CXXFLAGS) $(DEPFLAGS) $(CXXFLAGS) -c -o $@ $<

out/elf/.keep out/macho/.keep:
	mkdir -p $(@D)
	touch $@

$(MIMALLOC_LIB):
	mkdir -p out/mimalloc
	(cd out/mimalloc; CFLAGS=-DMI_USE_ENVIRON=0 cmake -G'Unix Makefiles' ../../third-party/mimalloc)
	$(MAKE) -C out/mimalloc mimalloc-static

$(TBB_LIB):
	mkdir -p out/tbb
	(cd out/tbb; cmake -G'Unix Makefiles' -DBUILD_SHARED_LIBS=OFF -DTBB_TEST=OFF -DCMAKE_CXX_FLAGS="$(CXXFLAGS) -D__TBB_DYNAMIC_LOAD_ENABLED=0" -DTBB_STRICT=OFF ../../third-party/tbb)
	$(MAKE) -C out/tbb tbb
	(cd out/tbb; ln -sf *_relwithdebinfo libs)

test tests check: all
ifeq ($(OS), Darwin)
	$(MAKE) -C test -f Makefile.darwin --no-print-directory
else
	$(MAKE) -C test -f Makefile.linux --no-print-directory --output-sync
endif
	@if test -t 1; then \
	  printf '\e[32mPassed all tests\e[0m\n'; \
	else \
	  echo 'Passed all tests'; \
	fi

test-arch:
	TEST_CC=${TRIPLE}-gcc \
	TEST_CXX=${TRIPLE}-g++ \
	TEST_GCC=${TRIPLE}-gcc \
	TEST_GXX=${TRIPLE}-g++ \
	OBJDUMP=${TRIPLE}-objdump \
	MACHINE=${MACHINE} \
	QEMU="qemu-${MACHINE} -L /usr/${TRIPLE}" \
	$(MAKE) test

test-all: all
	$(MAKE) test-arch TRIPLE=x86_64-linux-gnu MACHINE=x86_64
	$(MAKE) test-arch TRIPLE=i686-linux-gnu MACHINE=i386
	$(MAKE) test-arch TRIPLE=aarch64-linux-gnu MACHINE=aarch64
	$(MAKE) test-arch TRIPLE=arm-linux-gnueabihf MACHINE=arm
	$(MAKE) test-arch TRIPLE=riscv64-linux-gnu MACHINE=riscv64

install: all
	$(INSTALL) -d $D$(BINDIR)
	$(INSTALL_PROGRAM) mold $D$(BINDIR)
	$(STRIP) $D$(BINDIR)/mold

	$(INSTALL) -d $D$(LIBDIR)/mold
	$(INSTALL_DATA) mold-wrapper.so $D$(LIBDIR)/mold
	$(STRIP) $D$(LIBDIR)/mold/mold-wrapper.so

	$(INSTALL) -d $D$(LIBEXECDIR)/mold

# We want to make a symblink with a relative path, so that users can
# move the entire directory to other place without breaking the reference.
# GNU ln supports `--relative` to do that, but that's not supported by
# non-GNU systems. So we use Python to compute a relative path.
	ln -sf `python3 -c "import os.path; print(os.path.relpath('$(BINDIR)/mold', '$(LIBEXECDIR)/mold'))"` $D$(LIBEXECDIR)/mold/ld

	$(INSTALL) -d $D$(MANDIR)/man1
	$(INSTALL_DATA) docs/mold.1 $D$(MANDIR)/man1

	ln -sf mold $D$(BINDIR)/ld.mold
	ln -sf mold $D$(BINDIR)/ld64.mold

uninstall:
	rm -f $D$(BINDIR)/mold $D$(BINDIR)/ld.mold $D$(BINDIR)/ld64.mold
	rm -f $D$(MANDIR)/man1/mold.1
	rm -rf $D$(LIBDIR)/mold

test-asan test-ubsan:
	$(MAKE) USE_MIMALLOC=0 CXXFLAGS='-fsanitize=address -fsanitize=undefined -O0 -g' LDFLAGS='-fsanitize=address -fsanitize=undefined' test

test-tsan:
	$(MAKE) USE_MIMALLOC=0 CXXFLAGS='-fsanitize=thread -O0 -g' LDFLAGS=-fsanitize=thread test

clean:
	rm -rf *~ mold mold-wrapper.so out ld ld64 mold-*-linux.tar.gz

.PHONY: all test tests check clean test-arch test-all test-asan test-ubsan test-tsan

=== debian/changelog ===
mold (1.3.0+dfsg-1) unstable; urgency=medium

  * New upstream release
  * Remove debian/patches/disable-large-ali.diff as it is
    fixed upstream

 -- Sylvestre Ledru <sylvestre@debian.org>  Sat, 18 Jun 2022 09:35:23 +0200

mold (1.2.1+dfsg-1) unstable; urgency=medium

  * New upstream release

 -- Sylvestre Ledru <sylvestre@debian.org>  Thu, 28 Apr 2022 22:31:44 +0200

mold (1.2.0+dfsg-1) unstable; urgency=medium

  * New upstream release
    - Add dwarfdump as build dep

 -- Sylvestre Ledru <sylvestre@debian.org>  Thu, 21 Apr 2022 09:43:55 +0200

mold (1.1.1+dfsg-1) unstable; urgency=medium

  * New upstream release

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 08 Mar 2022 12:14:43 +0100

mold (1.1+dfsg-1) unstable; urgency=medium

  * New upstream release

 -- Sylvestre Ledru <sylvestre@debian.org>  Mon, 21 Feb 2022 08:42:18 +0100

=== debian/control ===
Source: mold
Section: devel
Priority: optional
Maintainer: Sylvestre Ledru <sylvestre@debian.org>
Build-Depends: debhelper-compat (= 13),
 clang, cmake, libstdc++-10-dev, libssl-dev, libxxhash-dev,
 zlib1g-dev, pkg-config, dwarfdump
Standards-Version: 4.6.0
Homepage: https://github.com/rui314/mold
Vcs-Browser: https://salsa.debian.org/pkg-llvm-team/mold
Vcs-Git: https://salsa.debian.org/pkg-llvm-team/mold.git
Rules-Requires-Root: no

Package: mold
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Drop-in linker
 mold is a faster drop-in replacement for existing Unix linkers.
 It is several times faster than the LLVM lld linker.
 mold is designed to increase developer productivity by reducing
 build time, especially in rapid debug-edit-rebuild cycles.

## mold 1.4.0+dfsg

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-VERSION = 1.3.0
+VERSION = 1.4.0
 
 PREFIX = /usr/local
 BINDIR = $(PREFIX)/bin
@@ -10,6 +10,15 @@
 INSTALL_PROGRAM = $(INSTALL)
 INSTALL_DATA = $(INSTALL) -m 644
 
+OS := $(shell uname -s)
+ARCH := $(shell uname -m)
+
+ifeq ($(OS), Darwin)
+  TESTS := $(wildcard test/macho/*.sh)
+else
+  TESTS := $(wildcard test/elf/*.sh)
+endif
+
 D = $(DESTDIR)
 
 # CXX defaults to `g++`. Rewrite it with a vendor-neutral compiler
@@ -23,10 +32,7 @@
 STRIP = strip
 
 SRCS = $(wildcard *.cc elf/*.cc macho/*.cc)
-OBJS = $(SRCS:%.cc=out/%.o)
-
-OS := $(shell uname -s)
-ARCH := $(shell uname -m)
+OBJS = $(SRCS:%.cc=out/%.o) out/rust-demangle.o
 
 IS_ANDROID = 0
 ifneq ($(findstring -android,$(shell $(CC) -dumpmachine)),)
@@ -39,7 +45,7 @@
 CXXFLAGS = -O2
 
 MOLD_CXXFLAGS := -std=c++20 -fno-exceptions -fno-unwind-tables \
-                 -fno-asynchronous-unwind-tables -Ithird-party/xxhash \
+                 -fno-asynchronous-unwind-tables -Ithird-party \
                  -DMOLD_VERSION=\"$(VERSION)\" -DLIBDIR="\"$(LIBDIR)\""
 
 MOLD_LDFLAGS := -pthread -lz -lm -ldl
@@ -103,9 +109,9 @@
   MOLD_LDFLAGS += -lcrypto
 endif
 
-# '-latomic' flag is needed building on riscv64 system.
+# '-latomic' flag is needed building on armv6/riscv64 systems.
 # Seems like '-atomic' would be better but not working.
-ifeq ($(ARCH), riscv64)
+ifneq (,$(filter armv6% riscv64, $(ARCH)))
   MOLD_LDFLAGS += -latomic
 endif
 
@@ -132,6 +138,9 @@
 mold-wrapper.so: elf/mold-wrapper.c
 	$(CC) $(DEPFLAGS) $(CFLAGS) -fPIC -shared -o $@ $< $(MOLD_WRAPPER_LDFLAGS) $(LDFLAGS)
 
+out/rust-demangle.o: third-party/rust-demangle/rust-demangle.c
+	$(CC) $(CFLAGS) -c -o $@ $<
+
 out/%.o: %.cc out/elf/.keep out/macho/.keep
 	$(CXX) $(MOLD_CXXFLAGS) $(DEPFLAGS) $(CXXFLAGS) -c -o $@ $<
 
@@ -146,16 +155,17 @@
 
 $(TBB_LIB):
 	mkdir -p out/tbb
-	(cd out/tbb; cmake -G'Unix Makefiles' -DBUILD_SHARED_LIBS=OFF -DTBB_TEST=OFF -DCMAKE_CXX_FLAGS="$(CXXFLAGS) -D__TBB_DYNAMIC_LOAD_ENABLED=0" -DTBB_STRICT=OFF ../../third-party/tbb)
+	(cd out/tbb; cmake -G'Unix Makefiles' -DCMAKE_BUILD_TYPE=RelWithDebInfo -DBUILD_SHARED_LIBS=OFF -DTBB_TEST=OFF -DCMAKE_CXX_FLAGS="$(CXXFLAGS) -D__TBB_DYNAMIC_LOAD_ENABLED=0" -DTBB_STRICT=OFF ../../third-party/tbb)
 	$(MAKE) -C out/tbb tbb
 	(cd out/tbb; ln -sf *_relwithdebinfo libs)
 
 test tests check: all
 ifeq ($(OS), Darwin)
-	$(MAKE) -C test -f Makefile.darwin --no-print-directory
-else
-	$(MAKE) -C test -f Makefile.linux --no-print-directory --output-sync
-endif
+	@$(MAKE) $(TESTS) --no-print-directory
+else
+	@$(MAKE) $(TESTS) --no-print-directory --output-sync
+endif
+
 	@if test -t 1; then \
 	  printf '\e[32mPassed all tests\e[0m\n'; \
 	else \
@@ -179,6 +189,20 @@
 	$(MAKE) test-arch TRIPLE=arm-linux-gnueabihf MACHINE=arm
 	$(MAKE) test-arch TRIPLE=riscv64-linux-gnu MACHINE=riscv64
 
+# macOS's GNU make hasn't been updated since 3.8.1 perhaps due a concern
+# of GPLv3. The --output-sync flag was introduced in GNU Make 4.0, so we
+# can't use that flag on macOS.
+#
+# `tail -r | tail -r` is a poor-man's way to enable full buffering on a
+# command output. `tail -r` outputs an input from the last line to the
+# first.
+$(TESTS):
+ifeq ($(OS), Darwin)
+	@set -o pipefail; ./$@ 2>&1 | tail -r | tail -r
+else
+	@./$@
+endif
+
 install: all
 	$(INSTALL) -d $D$(BINDIR)
 	$(INSTALL_PROGRAM) mold $D$(BINDIR)
@@ -216,4 +240,4 @@
 clean:
 	rm -rf *~ mold mold-wrapper.so out ld ld64 mold-*-linux.tar.gz
 
-.PHONY: all test tests check clean test-arch test-all test-asan test-ubsan test-tsan
+.PHONY: all test tests check clean test-arch test-all test-asan test-ubsan test-tsan $(TESTS)

=== third-party/tbb/CMakeLists.txt ===
# Copyright (c) 2020-2021 Intel Corporation
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

cmake_minimum_required(VERSION 3.1)

# Enable CMake policies

if (POLICY CMP0091)
    # The NEW behavior for this policy is to not place MSVC runtime library flags in the default
    # CMAKE_<LANG>_FLAGS_<CONFIG> cache entries and use CMAKE_MSVC_RUNTIME_LIBRARY abstraction instead.
    cmake_policy(SET CMP0091 NEW)
elseif (DEFINED CMAKE_MSVC_RUNTIME_LIBRARY)
    message(FATAL_ERROR "CMAKE_MSVC_RUNTIME_LIBRARY was defined while policy CMP0091 is not available. Use CMake 3.15 or newer.")
endif()

if (TBB_WINDOWS_DRIVER AND (NOT ("${CMAKE_MSVC_RUNTIME_LIBRARY}" STREQUAL MultiThreaded OR "${CMAKE_MSVC_RUNTIME_LIBRARY}" STREQUAL MultiThreadedDebug)))
    message(FATAL_ERROR "Enabled TBB_WINDOWS_DRIVER requires CMAKE_MSVC_RUNTIME_LIBRARY to be set to MultiThreaded or MultiThreadedDebug.")
endif()

# Enable support of minimum supported macOS version flag
if (APPLE)
    if (NOT CMAKE_CXX_OSX_DEPLOYMENT_TARGET_FLAG)
        set(CMAKE_CXX_OSX_DEPLOYMENT_TARGET_FLAG "-mmacosx-version-min=" CACHE STRING "Minimum macOS version flag")
    endif()
    if (NOT CMAKE_C_OSX_DEPLOYMENT_TARGET_FLAG)
        set(CMAKE_C_OSX_DEPLOYMENT_TARGET_FLAG "-mmacosx-version-min=" CACHE STRING "Minimum macOS version flag")
    endif()
endif()

# Until CMake 3.4.0 FindThreads.cmake requires C language enabled.
# Enable C language before CXX to avoid possible override of CMAKE_SIZEOF_VOID_P.
if (CMAKE_VERSION VERSION_LESS 3.4)
    enable_language(C)
endif()

file(READ include/oneapi/tbb/version.h _tbb_version_info)
string(REGEX REPLACE ".*#define TBB_VERSION_MAJOR ([0-9]+).*" "\\1" _tbb_ver_major "${_tbb_version_info}")
string(REGEX REPLACE ".*#define TBB_VERSION_MINOR ([0-9]+).*" "\\1" _tbb_ver_minor "${_tbb_version_info}")
string(REGEX REPLACE ".*#define TBB_VERSION_PATCH ([0-9]+).*" "\\1" _tbb_ver_patch "${_tbb_version_info}")
string(REGEX REPLACE ".*#define TBB_INTERFACE_VERSION ([0-9]+).*" "\\1" TBB_INTERFACE_VERSION "${_tbb_version_info}")
string(REGEX REPLACE ".*#define __TBB_BINARY_VERSION ([0-9]+).*" "\\1" TBB_BINARY_VERSION "${_tbb_version_info}")
set(TBB_BINARY_MINOR_VERSION ${_tbb_ver_minor})
set(TBBMALLOC_BINARY_VERSION 2)
set(TBBBIND_BINARY_VERSION 3)

project(TBB VERSION ${_tbb_ver_major}.${_tbb_ver_minor}.${_tbb_ver_patch} LANGUAGES CXX)
unset(_tbb_ver_major)
unset(_tbb_ver_minor)

include(CheckCXXCompilerFlag)
include(CheckSymbolExists)
include(GNUInstallDirs)

# ---------------------------------------------------------------------------------------------------------
# Handle C++ standard version.
if (NOT MSVC)  # no need to cover MSVC as it uses C++14 by default.
    if (NOT CMAKE_CXX_STANDARD)
        set(CMAKE_CXX_STANDARD 11)
    endif()

    if (CMAKE_CXX${CMAKE_CXX_STANDARD}_STANDARD_COMPILE_OPTION)  # if standard option was detected by CMake
        set(CMAKE_CXX_STANDARD_REQUIRED ON)
    else()  # if standard option wasn't detected by CMake (e.g. for Intel Compiler with CMake 3.1)
        # TBB_CXX_STD_FLAG should be added to targets via target_compile_options
        set(TBB_CXX_STD_FLAG -std=c++${CMAKE_CXX_STANDARD})

        check_cxx_compiler_flag(${TBB_CXX_STD_FLAG} c++${CMAKE_CXX_STANDARD})
        if (NOT c++${CMAKE_CXX_STANDARD})
            message(FATAL_ERROR "C++${CMAKE_CXX_STANDARD} (${TBB_CXX_STD_FLAG}) support is required")
        endif()
        unset(c++${CMAKE_CXX_STANDARD})
    endif()
endif()

set(CMAKE_CXX_EXTENSIONS OFF) # use -std=c++... instead of -std=gnu++...
# ---------------------------------------------------------------------------------------------------------

# Detect architecture (bitness).
if (CMAKE_SIZEOF_VOID_P EQUAL 4)
    set(TBB_ARCH 32)
else()
    set(TBB_ARCH 64)
endif()

option(TBB_TEST "Enable testing" ON)
option(TBB_EXAMPLES "Enable examples" OFF)
option(TBB_STRICT "Treat compiler warnings as errors" ON)
option(TBB_WINDOWS_DRIVER "Build as Universal Windows Driver (UWD)" OFF)
option(TBB_NO_APPCONTAINER "Apply /APPCONTAINER:NO (for testing binaries for Windows Store)" OFF)
option(TBB4PY_BUILD "Enable tbb4py build" OFF)
option(TBB_BUILD "Enable tbb build" ON)
option(TBBMALLOC_BUILD "Enable tbbmalloc build" ON)
option(TBB_CPF "Enable preview features of the library" OFF)
option(TBB_FIND_PACKAGE "Enable search for external oneTBB using find_package instead of build from sources" OFF)
option(TBB_DISABLE_HWLOC_AUTOMATIC_SEARCH "Disable HWLOC automatic search by pkg-config tool" OFF)

if (NOT DEFINED BUILD_SHARED_LIBS)
    set(BUILD_SHARED_LIBS ON)
endif()

if (NOT BUILD_SHARED_LIBS)
    set(CMAKE_POSITION_INDEPENDENT_CODE ON)
    message(WARNING "You are building oneTBB as a static library. This is highly discouraged and such configuration is not supported. Consider building a dynamic library to avoid unforeseen issues.")
endif()

if (NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
    set(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING "Build type" FORCE)
    message(STATUS "CMAKE_BUILD_TYPE is not specified. Using default: ${CMAKE_BUILD_TYPE}")
    # Possible values of build type for cmake-gui
    set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release" "MinSizeRel" "RelWithDebInfo")
endif()

# -------------------------------------------------------------------
# Files and folders naming
set(CMAKE_DEBUG_POSTFIX _debug)

if (NOT DEFINED TBB_OUTPUT_DIR_BASE)
    if (MSVC)
        if (NOT DEFINED CMAKE_MSVC_RUNTIME_LIBRARY OR CMAKE_MSVC_RUNTIME_LIBRARY MATCHES DLL)
            set(_tbb_msvc_runtime _md)
        else()
            set(_tbb_msvc_runtime _mt)
        endif()

        if (WINDOWS_STORE)
            if (TBB_NO_APPCONTAINER)
                set(_tbb_win_store _wsnoappcont)
            else()
                set(_tbb_win_store _ws)
            endif()
        elseif(TBB_WINDOWS_DRIVER)
            set(_tbb_win_store _wd)
        endif()
    endif()

     string(REGEX MATCH "^([0-9]+\.[0-9]+|[0-9]+)" _tbb_compiler_version_short ${CMAKE_CXX_COMPILER_VERSION})
     string(TOLOWER ${CMAKE_CXX_COMPILER_ID}_${_tbb_compiler_version_short}_cxx${CMAKE_CXX_STANDARD}_${TBB_ARCH}${_tbb_msvc_runtime}${_tbb_win_store} TBB_OUTPUT_DIR_BASE)
     unset(_tbb_msvc_runtime)
     unset(_tbb_win_store)
     unset(_tbb_compiler_version_short)
endif()

foreach(output_type LIBRARY ARCHIVE PDB RUNTIME)
    if (CMAKE_BUILD_TYPE)
        string(TOLOWER ${CMAKE_BUILD_TYPE} _tbb_build_type_lower)
        set(CMAKE_${output_type}_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/${TBB_OUTPUT_DIR_BASE}_${_tbb_build_type_lower})
        unset(_tbb_build_type_lower)
    endif()

    if (CMAKE_CONFIGURATION_TYPES)
        foreach(suffix ${CMAKE_CONFIGURATION_TYPES})
            string(TOUPPER ${suffix} _tbb_suffix_upper)
            string(TOLOWER ${suffix} _tbb_suffix_lower)
            set(CMAKE_${output_type}_OUTPUT_DIRECTORY_${_tbb_suffix_upper} ${CMAKE_BINARY_DIR}/${TBB_OUTPUT_DIR_BASE}_${_tbb_suffix_lower})
        endforeach()
        unset(_tbb_suffix_lower)
        unset(_tbb_suffix_upper)
    endif()
endforeach()

# -------------------------------------------------------------------

# -------------------------------------------------------------------
# Common dependencies
set(THREADS_PREFER_PTHREAD_FLAG TRUE)
find_package(Threads REQUIRED)
# -------------------------------------------------------------------

file(GLOB FILES_WITH_EXTRA_TARGETS ${CMAKE_CURRENT_SOURCE_DIR}/cmake/*.cmake)
foreach(FILE_WITH_EXTRA_TARGETS ${FILES_WITH_EXTRA_TARGETS})
    include(${FILE_WITH_EXTRA_TARGETS})
endforeach()

set(TBB_COMPILER_SETTINGS_FILE ${CMAKE_CURRENT_SOURCE_DIR}/cmake/compilers/${CMAKE_CXX_COMPILER_ID}.cmake)
if (EXISTS ${TBB_COMPILER_SETTINGS_FILE})
    include(${TBB_COMPILER_SETTINGS_FILE})
else()
    message(WARNING "TBB compiler settings not found ${TBB_COMPILER_SETTINGS_FILE}")
endif()

if (TBB_FIND_PACKAGE OR TBB_DIR)
    # Allow specifying external TBB to test with.
    # Do not add main targets and installation instructions in that case.
    message(STATUS "Using external TBB for testing")
    find_package(TBB REQUIRED)
else()
    if (TBB_BUILD)
        add_subdirectory(src/tbb)
    endif()
    if (NOT "${CMAKE_SYSTEM_PROCESSOR}" MATCHES "mips")
        if (TBBMALLOC_BUILD)
            add_subdirectory(src/tbbmalloc)
            add_subdirectory(src/tbbmalloc_proxy)
        endif()
        if (APPLE)
            message(STATUS "TBBBind build targets are disabled due to unsupported environment")
        else()
            add_subdirectory(src/tbbbind)
        endif()
    endif()

    # -------------------------------------------------------------------
    # Installation instructions
    include(CMakePackageConfigHelpers)

    install(DIRECTORY include/
            DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
            COMPONENT devel)

    install(EXPORT ${PROJECT_NAME}Targets
            NAMESPACE TBB::
            DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}
            COMPONENT devel)
    file(WRITE ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}Config.cmake
               "include(\${CMAKE_CURRENT_LIST_DIR}/${PROJECT_NAME}Targets.cmake)\n")

    write_basic_package_version_file("${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake"
                                     COMPATIBILITY AnyNewerVersion)

    install(FILES "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}Config.cmake"
                  "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake"
            DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}
            COMPONENT devel)

    install(FILES "README.md"
            DESTINATION ${CMAKE_INSTALL_DOCDIR}
            COMPONENT devel)
    # -------------------------------------------------------------------
endif()

if (TBB_TEST)
    enable_testing()
    add_subdirectory(test)
endif()

if (TBB_EXAMPLES)
    add_subdirectory(examples)
endif()

if (TBB_BENCH)
    if (NOT EXISTS ${CMAKE_CURRENT_LIST_DIR}/benchmark)
        message(FATAL_ERROR "Benchmarks are not supported yet")
    endif()

    enable_testing()
    add_subdirectory(benchmark)
endif()

if (ANDROID_PLATFORM)
    if (${ANDROID_STL} STREQUAL "c++_shared")
        configure_file(
        "${ANDROID_NDK}/sources/cxx-stl/llvm-libc++/libs/${ANDROID_ABI}/libc++_shared.so"
        "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}/libc++_shared.so"
        COPYONLY)
    endif()
    # This custom target may be implemented without separate CMake script, but it requires
    # ADB(Android Debug Bridge) executable file availability, so to incapsulate this requirement
    # only for corresponding custom target, it was implemented by this way.
    add_custom_target(device_environment_cleanup COMMAND ${CMAKE_COMMAND}
                      -P ${CMAKE_CURRENT_SOURCE_DIR}/cmake/android/device_environment_cleanup.cmake)
endif()

# These functions or flags are glibc-specific.
check_symbol_exists(getcontext ucontext.h HAVE_GETCONTEXT)

if (TBB4PY_BUILD)
    add_subdirectory(python)
endif()

# Keep it the last instruction.
add_subdirectory(cmake/post_install)

=== third-party/xxhash/tests/Makefile ===
# ################################################################
# xxHash Makefile
# Copyright (C) 2012-2020 Yann Collet
#
# GPL v2 License
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
#
# You can contact the author at:
#   - xxHash homepage: https://www.xxhash.com
#   - xxHash source repository: https://github.com/Cyan4973/xxHash
# ################################################################

CFLAGS += -Wall -Wextra -Wundef -g

CP = cp
NM = nm
GREP = grep
XXHSUM_DIR = ..
XXHSUM = $(XXHSUM_DIR)/xxhsum

# Define *.exe as extension for Windows systems
ifneq (,$(filter Windows%,$(OS)))
EXT =.exe
else
EXT =
endif

ifneq (,$(filter %UTF-8,$(LANG)))
ENABLE_UNICODE ?= 1
else
ENABLE_UNICODE ?= 0
endif

.PHONY: default
default: all

.PHONY: all
all: test

.PHONY: test
test: test_multiInclude test_unicode

.PHONY: test_multiInclude
test_multiInclude:
	@$(MAKE) clean
	# compile without xxhash.o, ensure symbols exist within target
	# Note: built using only default rules
	$(MAKE) multiInclude
	@$(MAKE) clean
	# compile with xxhash.o, to detect duplicated symbols
	$(MAKE) multiInclude_withxxhash
	@$(MAKE) clean
	# compile with XXH_NAMESPACE before XXH_INLINE_ALL
	CPPFLAGS=-DXXH_NAMESPACE=TESTN_ $(MAKE) multiInclude
	# no symbol prefixed TESTN_ should exist
	! $(NM) multiInclude | $(GREP) TESTN_
	$(MAKE) clean
	# compile xxhash.o with XXH_NAMESPACE
	CPPFLAGS=-DXXH_NAMESPACE=TESTN_ $(MAKE) multiInclude_withxxhash
	# symbols prefixed TESTN_ should exist in xxhash.o (though not be invoked)
	$(NM) multiInclude_withxxhash | $(GREP) TESTN_
	$(MAKE) clean

.PHONY: test_ppc_redefine
test_ppc_redefine: ppc_define.c
	@$(MAKE) clean
	$(CC) $(CPPFLAGS) $(CFLAGS) -c $^

.PHONY: $(XXHSUM)
$(XXHSUM):
	$(MAKE) -C $(XXHSUM_DIR) xxhsum
	$(CP) $(XXHSUM) .

# Make sure that Unicode filenames work.
# https://github.com/Cyan4973/xxHash/issues/293
.PHONY: test_unicode
ifeq (0,$(ENABLE_UNICODE))
test_unicode:
	@echo "Skipping Unicode test, your terminal doesn't appear to support UTF-8."
	@echo "Try with ENABLE_UNICODE=1"
else
test_unicode: $(XXHSUM) generate_unicode_test.c
	# Generate a Unicode filename test dynamically
	# to keep UTF-8 out of the source tree.
	$(CC) $(CFLAGS) $(LDFLAGS) generate_unicode_test.c -o generate_unicode_test$(EXT)
	./generate_unicode_test$(EXT)
	$(SHELL) ./unicode_test.sh
endif

xxhash.o: ../xxhash.c ../xxhash.h
	$(CC) $(CFLAGS) $(CPPFLAGS) $(LDFLAGS) -c -o $@ $<

multiInclude_withxxhash: multiInclude.o xxhash.o
	$(CC) $(CFLAGS) $(CPPFLAGS) $(LDFLAGS) -o $@ $^

clean:
	@$(RM) *.o
	@$(RM) multiInclude multiInclude_withxxhash
	@$(RM) *.unicode generate_unicode_test$(EXT) unicode_test.* xxhsum*

=== debian/changelog ===
mold (1.4.0+dfsg-1) unstable; urgency=medium

  [ Roger Shimizu ]
  * d/control:
    - Sort B-D list.
    - Remove libstdc++-10-dev and unused clang from B-D list.
    - Add libmimalloc-dev and libtbb-dev to B-D list.
  * debian/rules:
    - Prefer to use system library mimalloc and tbb.
  * debian/patches:
    - Add patch to avoid overwriting C*FLAGS set by debian/rules.

  [ Sylvestre Ledru ]
  * New upstream release
  * Add gdb as a build dep for tests
  * For now, use TBB from the tree
    See https://github.com/rui314/mold/issues/600

 -- Sylvestre Ledru <sylvestre@debian.org>  Fri, 05 Aug 2022 09:43:13 +0200

mold (1.3.1+dfsg-1) unstable; urgency=medium

  * New upstream release

 -- Sylvestre Ledru <sylvestre@debian.org>  Sat, 02 Jul 2022 11:25:04 +0200

## mold 1.4.1+dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18)
project(mold VERSION 1.4.1)

include(CMakeDependentOption)

# FIXME: this is for parity with the makefiles that install directly to
# <prefix>/lib
#
# NOTE: defining this before including GNUInstallDirs makes its platform
# detection a noop
set(CMAKE_INSTALL_LIBDIR lib CACHE PATH "")
include(GNUInstallDirs)

# Add -fuse-ld=mold if accepted by the compiler.
option(MOLD_USE_MOLD "Use mold to build mold" ON)
if(MOLD_USE_MOLD)
  include(CheckLinkerFlag)
  check_linker_flag(CXX -fuse-ld=mold CXX_SUPPORTS_FUSE_MOLD)
  if(CXX_SUPPORTS_FUSE_MOLD)
    add_link_options(-fuse-ld=mold)
  endif()
endif()

add_executable(mold)
target_compile_features(mold PRIVATE cxx_std_20)
target_link_libraries(mold PRIVATE ${CMAKE_DL_LIBS})

if("${CMAKE_CXX_COMPILER_FRONTEND_VARIANT}" STRLESS "MSVC")
  target_compile_options(mold PRIVATE
    -fno-exceptions
    -fno-unwind-tables
    -fno-asynchronous-unwind-tables)
endif()

# Build mold with -flto if MOLD_LTO=On
option(MOLD_LTO "Build mold with link-time optimization enabled")
if(MOLD_LTO)
  set_property(TARGET mold PROPERTY INTERPROCEDURAL_OPTIMIZATION ON)
endif()

# Handle MOLD_USE_ASAN and MOLD_USE_TSAN
option(MOLD_USE_ASAN "Build mold with AddressSanitizer" OFF)
if(MOLD_USE_ASAN)
  target_compile_options(mold PRIVATE -fsanitize=address -fsanitize=undefined)
  target_link_options(mold PRIVATE -fsanitize=address -fsanitize=undefined)
endif()

option(MOLD_USE_TSAN "Build mold with ThreadSanitizer" OFF)
if(MOLD_USE_TSAN)
  target_compile_options(mold PRIVATE -fsanitize=thread)
  target_link_options(mold PRIVATE -fsanitize=thread)
endif()

# Static link libstdc++ and libcrypto if MOLD_MOSTLY_STATIC=On
option(MOLD_MOSTLY_STATIC "Statically link libstdc++ and libcrypto" OFF)
if(MOLD_MOSTLY_STATIC)
  target_link_options(mold PRIVATE -static-libstdc++)
  target_link_libraries(mold PRIVATE libcrypto.a)
endif()

# Setup zlib
find_package(ZLIB QUIET)
if(ZLIB_FOUND)
  target_link_libraries(mold PRIVATE ZLIB::ZLIB)
else()
  add_subdirectory(third-party/zlib EXCLUDE_FROM_ALL)
  target_include_directories(zlibstatic INTERFACE third-party/zlib
    $<TARGET_PROPERTY:zlibstatic,BINARY_DIR>)
  target_link_libraries(mold PRIVATE zlibstatic)
endif()

# Setup mimalloc
cmake_dependent_option(MOLD_USE_MIMALLOC "Use mimalloc" ON
  "NOT APPLE;NOT ANDROID" OFF)
cmake_dependent_option(
  MOLD_USE_SYSTEM_MIMALLOC "Use system or vendored mimalloc" OFF
  MOLD_USE_MIMALLOC OFF)

if(MOLD_USE_MIMALLOC)
  if(MOLD_USE_SYSTEM_MIMALLOC)
    find_package(mimalloc REQUIRED)
    target_compile_definitions(mimalloc INTERFACE USE_SYSTEM_MIMALLOC)
    target_link_libraries(mold PRIVATE mimalloc)
  else()
    function(mold_add_mimalloc)
      set(MI_BUILD_STATIC ON)
      option(MI_BUILD_TESTS "Build test executables" OFF)
      add_subdirectory(third-party/mimalloc EXCLUDE_FROM_ALL)
      target_compile_definitions(mimalloc-static PRIVATE MI_USE_ENVIRON=0)
      target_link_libraries(mold PRIVATE mimalloc-static)
    endfunction()

    mold_add_mimalloc()
  endif()
endif()

# Setup TBB
option(MOLD_USE_SYSTEM_TBB "Use system or vendored TBB" OFF)
if(MOLD_USE_SYSTEM_TBB)
  find_package(TBB REQUIRED)
  target_link_libraries(mold PRIVATE TBB::tbb)
else()
  function(mold_add_tbb)
    set(BUILD_SHARED_LIBS OFF)
    set(TBB_TEST OFF CACHE INTERNAL "")
    set(TBB_STRICT OFF CACHE INTERNAL "")
    add_subdirectory(third-party/tbb EXCLUDE_FROM_ALL)
    target_compile_definitions(tbb PRIVATE __TBB_DYNAMIC_LOAD_ENABLED=0)
    target_link_libraries(mold PRIVATE TBB::tbb)
  endfunction()

  mold_add_tbb()
endif()

# MOLD_X86_64_ONLY is a developer-only option. You should not use it
# for creating an executable for production use.
option(MOLD_X86_64_ONLY "Developer-only option" OFF)
if(MOLD_X86_64_ONLY)
  set(CMAKE_BUILD_TYPE "Debug")
  target_compile_options(mold PRIVATE -ffunction-sections -fdata-sections
    -DMOLD_DEBUG_X86_64_ONLY)
  target_link_options(mold PRIVATE -Wl,--gc-sections)
endif()

if(WIN32)
  if(NOT CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
    message(FATAL_ERROR
      "Your compiler is not supported; install Clang from Visual Studio Installer and re-run cmake with '-T clangcl'")
   endif()

  target_compile_definitions(mold PRIVATE NOGDI NOMINMAX)

  target_sources(mold PRIVATE
    elf/lto-win32.cc
    macho/lto-win32.cc)
else()
  include(CheckLibraryExists)
  check_library_exists(m pow "" LIBM_FOUND)
  if(LIBM_FOUND)
    target_link_libraries(mold PRIVATE m)
  endif()

  target_sources(mold PRIVATE
    elf/lto-unix.cc
    elf/subprocess.cc
    macho/lto-unix.cc)
endif()

if(NOT APPLE AND NOT WIN32)
  add_library(mold-wrapper SHARED)
  install(TARGETS mold-wrapper DESTINATION ${CMAKE_INSTALL_LIBDIR}/mold)

  # Remove the default `lib` prefix
  set_target_properties(mold-wrapper PROPERTIES PREFIX "")
  target_link_libraries(mold-wrapper PRIVATE ${CMAKE_DL_LIBS})
  target_sources(mold-wrapper PRIVATE elf/mold-wrapper.c)
endif()

if(NOT APPLE AND NOT MOLD_MOSTLY_STATIC AND NOT WIN32)
  find_package(OpenSSL REQUIRED COMPONENTS Crypto)
  target_link_libraries(mold PRIVATE OpenSSL::Crypto)
endif()

if(CMAKE_SYSTEM_PROCESSOR MATCHES riscv64
    OR CMAKE_SYSTEM_PROCESSOR MATCHES armv6)
  target_link_libraries(mold PRIVATE atomic)
endif()

set_property(SOURCE main.cc elf/lto-unix.cc macho/output-chunks.cc APPEND PROPERTY
  COMPILE_DEFINITIONS "MOLD_VERSION=\"${CMAKE_PROJECT_VERSION}\"")

find_package(Python3 REQUIRED)

add_custom_target(UpdateGitHash
  COMMAND ${Python3_EXECUTABLE} ${CMAKE_SOURCE_DIR}/update-git-hash.py
    ${CMAKE_SOURCE_DIR} git-hash.cc
  DEPENDS update-git-hash.py
  BYPRODUCTS git-hash.cc
  VERBATIM)

add_dependencies(mold UpdateGitHash)

target_sources(mold PRIVATE
  compress.cc
  demangle.cc
  elf/arch-arm32.cc
  elf/arch-arm64.cc
  elf/arch-i386.cc
  elf/arch-riscv.cc
  elf/arch-x86-64.cc
  elf/cmdline.cc
  elf/dwarf.cc
  elf/gc-sections.cc
  elf/icf.cc
  elf/input-files.cc
  elf/input-sections.cc
  elf/linker-script.cc
  elf/main.cc
  elf/mapfile.cc
  elf/output-chunks.cc
  elf/passes.cc
  elf/relocatable.cc
  filepath.cc
  git-hash.cc
  glob.cc
  hyperloglog.cc
  macho/arch-arm64.cc
  macho/arch-x86-64.cc
  macho/cmdline.cc
  macho/dead-strip.cc
  macho/input-files.cc
  macho/input-sections.cc
  macho/main.cc
  macho/mapfile.cc
  macho/output-chunks.cc
  macho/tapi.cc
  macho/yaml.cc
  main.cc
  multi-glob.cc
  perf.cc
  strerror.cc
  tar.cc
  third-party/rust-demangle/rust-demangle.c
  uuid.cc
  )

include(CTest)

if(BUILD_TESTING)
  # Create the ld and ld64 symlinks required for testing
  if(NOT WIN32)
    add_custom_command(
      TARGET mold POST_BUILD
      COMMAND ${CMAKE_COMMAND} -E create_symlink mold ld
      COMMAND ${CMAKE_COMMAND} -E create_symlink mold ld64
      WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
      VERBATIM)
  endif()

  if(${APPLE})
    add_subdirectory(test/macho)
  elseif(${UNIX})
    add_subdirectory(test/elf)
  endif()
endif()

if(NOT CMAKE_SKIP_INSTALL_RULES)
  install(TARGETS mold)
  install(FILES LICENSE DESTINATION ${CMAKE_INSTALL_DOCDIR})
  install(FILES docs/mold.1 DESTINATION ${CMAKE_INSTALL_MANDIR}/man1/)
  install(CODE "
        file(RELATIVE_PATH RELPATH
             /${CMAKE_INSTALL_LIBEXECDIR}/mold /${CMAKE_INSTALL_BINDIR}/mold)
        execute_process(COMMAND ${CMAKE_COMMAND} -E make_directory
            \${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBEXECDIR}/mold)
        execute_process(COMMAND ${CMAKE_COMMAND} -E create_symlink \${RELPATH}
            \${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBEXECDIR}/mold/ld)
        execute_process(COMMAND ${CMAKE_COMMAND} -E create_symlink mold
            \${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_BINDIR}/ld.mold)
        execute_process(COMMAND ${CMAKE_COMMAND} -E create_symlink mold
            \${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_BINDIR}/ld64.mold)
        execute_process(COMMAND ${CMAKE_COMMAND} -E create_symlink mold.1
            \${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_MANDIR}/man1/ld.mold.1)")
endif()

=== Makefile ===
--- 
+++ 
@@ -1,10 +1,11 @@
-VERSION = 1.4.0
+VERSION = 1.4.1
 
 PREFIX = /usr/local
 BINDIR = $(PREFIX)/bin
 LIBDIR = $(PREFIX)/lib
 LIBEXECDIR = $(PREFIX)/libexec
 MANDIR = $(PREFIX)/share/man
+DOCDIR = $(PREFIX)/share/doc
 
 INSTALL = install
 INSTALL_PROGRAM = $(INSTALL)
@@ -32,7 +33,7 @@
 STRIP = strip
 
 SRCS = $(wildcard *.cc elf/*.cc macho/*.cc)
-OBJS = $(SRCS:%.cc=out/%.o) out/rust-demangle.o
+OBJS = $(SRCS:%.cc=out/%.o) out/rust-demangle.o out/git-hash.o
 
 IS_ANDROID = 0
 ifneq ($(findstring -android,$(shell $(CC) -dumpmachine)),)
@@ -45,19 +46,10 @@
 CXXFLAGS = -O2
 
 MOLD_CXXFLAGS := -std=c++20 -fno-exceptions -fno-unwind-tables \
-                 -fno-asynchronous-unwind-tables -Ithird-party \
+                 -fno-asynchronous-unwind-tables \
                  -DMOLD_VERSION=\"$(VERSION)\" -DLIBDIR="\"$(LIBDIR)\""
 
 MOLD_LDFLAGS := -pthread -lz -lm -ldl
-
-# Get a hash of the current git head. We don't want to use the git
-# command because the command prints out a warning if running under
-# sudo.
-GIT_HASH := $(shell [ -f .git/HEAD ] && if grep -q '^ref:' .git/HEAD; then cat .git/`sed 's/^ref: //' .git/HEAD`; else cat .git/HEAD; fi)
-
-ifneq ($(GIT_HASH),)
-  MOLD_CXXFLAGS += -DGIT_HASH=\"$(GIT_HASH)\"
-endif
 
 LTO = 0
 ifeq ($(LTO), 1)
@@ -85,6 +77,10 @@
   endif
 endif
 
+# Note: Do NOT specify `SYSTEM_TBB=1` unless your system-wide OneTBB
+# library is compiled with https://github.com/oneapi-src/oneTBB/pull/824.
+# mold with an unpatched OneTBB is unstable when doing LTO if the system
+# is under high load.
 ifdef SYSTEM_TBB
   MOLD_LDFLAGS += -ltbb
 else
@@ -129,6 +125,14 @@
 all: mold mold-wrapper.so
 
 -include $(SRCS:%.cc=out/%.d)
+
+out/git-hash.cc: FORCE
+	./update-git-hash.py . out/git-hash.cc
+
+FORCE:
+
+out/git-hash.o: out/git-hash.cc
+	$(CXX) $(MOLD_CXXFLAGS) $(CXXFLAGS) -c -o $@ $<
 
 mold: $(OBJS) $(MIMALLOC_LIB) $(TBB_LIB)
 	$(CXX) $(OBJS) -o $@ $(MOLD_LDFLAGS) $(LDFLAGS)
@@ -209,8 +213,11 @@
 	$(STRIP) $D$(BINDIR)/mold
 
 	$(INSTALL) -d $D$(LIBDIR)/mold
+
+ifneq ($(OS), Darwin)
 	$(INSTALL_DATA) mold-wrapper.so $D$(LIBDIR)/mold
 	$(STRIP) $D$(LIBDIR)/mold/mold-wrapper.so
+endif
 
 	$(INSTALL) -d $D$(LIBEXECDIR)/mold
 
@@ -222,6 +229,10 @@
 
 	$(INSTALL) -d $D$(MANDIR)/man1
 	$(INSTALL_DATA) docs/mold.1 $D$(MANDIR)/man1
+	ln -sf mold.1 $D$(MANDIR)/man1/ld.mold.1
+
+	$(INSTALL) -d $D$(DOCDIR)/mold
+	$(INSTALL_DATA) LICENSE $D$(DOCDIR)/mold/
 
 	ln -sf mold $D$(BINDIR)/ld.mold
 	ln -sf mold $D$(BINDIR)/ld64.mold

=== test/elf/CMakeLists.txt ===
set(MOLD_ELF_TESTS
  absolute-symbols
  allow-multiple-definition
  ar-alignment
  arm32-thumb-interwork
  as-needed
  as-needed-weak
  as-needed2
  auxiliary
  basic
  bno-symbolic
  bsymbolic
  bsymbolic-functions
  bug178
  build-id
  canonical-plt
  cmdline
  color-diagnostics
  comment
  common
  common-archive
  common-ref
  compress-debug-sections
  compressed-debug-info
  compressed-debug-info-gnu
  copyrel
  copyrel-protected
  copyrel-relro
  dead-debug-sections
  debug-macro-section
  default-symver
  defsym
  defsym2
  demangle
  demangle-rust
  dependency-file
  disable-new-dtags
  discard
  dso-undef
  dt-init
  dt-needed
  duplicate-error
  dynamic
  dynamic-dt-debug
  dynamic-linker
  dynamic-list
  dynamic-list2
  dynamic-list3
  emit-relocs
  empty-file
  empty-input
  empty-version
  emulation-deduction
  entry
  exception
  exception-mcmodel-large
  exclude-libs
  exclude-libs2
  exclude-libs3
  execstack
  execstack-if-needed
  export-dynamic
  export-from-exe
  fatal-warnings
  filler
  filter
  func-addr
  gc-sections
  gdb-index-compress-output
  gdb-index-dwarf2
  gdb-index-dwarf3
  gdb-index-dwarf4
  gdb-index-dwarf5
  gdb-index-empty
  glibc-2.22-bug
  gnu-hash
  gnu-linkonce
  gnu-retain
  gnu-unique
  gnu-warning
  hello-dynamic
  hello-static
  help
  hidden-undef
  icf
  icf-small
  ifunc-dso
  ifunc-dynamic
  ifunc-export
  ifunc-static
  ifunc-static-pie
  image-base
  incompatible-libs
  incompatible-libs2
  incompatible-obj
  init
  init-array
  init-array-priorities
  init-array-readonly
  init-in-dso
  initfirst
  interpose
  invalid-version-script
  large-alignment
  large-alignment-dso
  link-order
  linker-script
  linker-script-defsym
  linker-script2
  linker-script3
  linker-script4
  lto-archive
  lto-dso
  lto-gcc
  lto-llvm
  lto-version-script
  many-sections
  mergeable-records
  mergeable-strings
  missing-but-ok
  missing-error
  mold-wrapper
  mold-wrapper2
  no-quick-exit
  nocopyreloc
  noinhibit-exec
  non-canonical-plt
  nostdlib
  note
  note-property
  note2
  now
  oformat-binary
  omagic
  pack-dyn-relocs-relr
  package-metadata
  pie
  plt
  plt-dso
  pltgot
  preinit-array
  print-dependencies
  protected
  protected-dynsym
  push-pop-state
  relax
  reloc
  reloc-overflow
  reloc-rodata
  reloc-zero
  relocatable
  relocatable-archive
  relro
  repro
  require-defined
  response-file
  retain-symbols-file
  reverse-sections
  rodata-name
  rosegment
  rpath
  run
  run-clang
  section-alignment
  section-name
  section-start
  shared
  shuffle-sections
  shuffle-sections-seed
  soname
  start-lib
  start-stop-symbol
  static-archive
  static-pie
  stdout
  strip
  symbol-rank
  symbol-version
  symbol-version2
  symbol-version3
  symtab
  symtab-dso
  symtab-section-symbols
  synthetic-symbols
  sysroot
  sysroot-linker-script
  sysroot2
  thin-archive
  thread-count
  tls-common
  tls-dso
  tls-gd
  tls-gd-mcmodel-large
  tls-gd-noplt
  tls-gd2
  tls-ie
  tls-large-tbss
  tls-ld
  tls-ld-mcmodel-large
  tls-ld-noplt
  tls-le
  tls-module-base
  tls-nopic
  tls-pic
  tlsdesc
  tlsdesc-import
  tlsdesc-static
  trace
  trace-symbol
  undefined
  unique
  unresolved-symbols
  verbose
  version
  version-script
  version-script10
  version-script11
  version-script12
  version-script13
  version-script14
  version-script15
  version-script16
  version-script17
  version-script2
  version-script3
  version-script4
  version-script5
  version-script6
  version-script7
  version-script8
  version-script9
  versioned-undef
  visibility
  warn-common
  warn-execstack
  warn-once
  warn-shared-textrel
  warn-textrel
  warn-unresolved-symbols
  weak-export-dso
  weak-export-exe
  weak-undef
  whole-archive
  wrap
  z-cet-report
  z-defs
  z-ibt
  z-ibtplt
  z-max-page-size
  z-nodefaultlib
  z-nodump
  z-now
  z-origin
  z-separate-code
  z-shstk
  z-text
  z-unknown
  )

option(MOLD_ENABLE_QEMU_TESTS "Enable tests for other targets" OFF)

function(mold_add_arch_test NAME TRIPLE MACHINE)
  if(NOT ${CMAKE_HOST_SYSTEM_PROCESSOR} STREQUAL ${MACHINE})
    set(TEST_NAME "${MACHINE}-${NAME}")
    add_test(NAME ${TEST_NAME}
      COMMAND bash -x ${CMAKE_CURRENT_LIST_DIR}/${NAME}.sh
      WORKING_DIRECTORY ${mold_BINARY_DIR})

    set(TEST_ENV
      TEST_CC=${TRIPLE}-gcc
      TEST_CXX=${TRIPLE}-g++
      TEST_GCC=${TRIPLE}-gcc
      TEST_GXX=${TRIPLE}-g++
      OBJDUMP=${TRIPLE}-objdump
      MACHINE=${MACHINE}
      "QEMU=qemu-${MACHINE} -L /usr/${TRIPLE}")
    set_tests_properties(${TEST_NAME} PROPERTIES ENVIRONMENT "${TEST_ENV}")
  endif()
endfunction()

foreach(TEST IN LISTS MOLD_ELF_TESTS)
  add_test(NAME "${CMAKE_HOST_SYSTEM_PROCESSOR}-${TEST}"
    COMMAND bash -x ${CMAKE_CURRENT_LIST_DIR}/${TEST}.sh
    WORKING_DIRECTORY ${mold_BINARY_DIR})

  if(MOLD_ENABLE_QEMU_TESTS)
    mold_add_arch_test(${TEST} x86_64-linux-gnu x86_64)
    mold_add_arch_test(${TEST} i686-linux-gnu i386)
    mold_add_arch_test(${TEST} aarch64-linux-gnu aarch64)
    mold_add_arch_test(${TEST} arm-linux-gnueabihf arm)
    mold_add_arch_test(${TEST} riscv64-linux-gnu riscv64)
  endif()
endforeach()

=== test/macho/CMakeLists.txt ===
set(MOLD_MACHO_TESTS
  U
  Z
  add-ast-path
  add-empty-section
  adhoc-codesign
  all-load
  application-extension
  archive
  baserel
  basic
  bss
  bundle
  comdat
  common
  common-alignment
  cstring
  data-reloc
  dead-strip
  dead-strip-dylibs
  dead-strip-dylibs2
  dependency-info
  dlinfo
  duplicate-error
  dylib
  entry
  exception
  export-dynamic
  exported-symbols-list
  filepath
  filepath2
  force-load
  framework
  headerpad
  headerpad-max-install-names
  hello
  hello2
  hello3
  hello4
  hello5
  hidden-l
  install-name
  lc-build-version
  lc-linker-option
  lib1
  libunwind
  linker-optimization-hints
  lto
  lto-dead-strip-dylibs
  macos-version-min
  map
  merge-scope
  missing-error
  needed-framework
  needed-l
  no-function-starts
  objc
  objc-selector
  object-path-lto
  order-file
  pagezero-size
  pagezero-size2
  pagezero-size3
  platform-version
  private-extern
  reexport-l
  reproducibility
  response-file
  rpath
  search-dylibs-first
  search-paths-first
  sectcreate
  stack-size
  start-stop-symbol
  subsections-via-symbols
  syslibroot
  tbd
  tbd-add
  tbd-hide
  tbd-install-name
  tbd-previous
  tbd-reexport
  tls
  tls2
  undef
  unexported-symbols-list
  universal
  unkown-tbd-target
  uuid
  uuid2
  weak-def
  weak-def-dylib
  weak-def-ref
  weak-l
  weak-undef
  )

foreach(TEST IN LISTS MOLD_MACHO_TESTS)
  add_test(NAME ${TEST}
    COMMAND bash -x ${CMAKE_CURRENT_LIST_DIR}/${TEST}.sh
    WORKING_DIRECTORY ${mold_BINARY_DIR})
endforeach()

=== debian/changelog ===
mold (1.4.1+dfsg-1) unstable; urgency=medium

  * New upstream release
  * Silent 
    source-contains-prebuilt-ms-help-file third-party/zlib/contrib/dotzlib/DotZLib.chm
    will be removed at the next release

 -- Sylvestre Ledru <sylvestre@debian.org>  Mon, 22 Aug 2022 17:39:41 +0200
